class RNN(Module):
  __parameters__ = ["weight_ih_l0", "weight_hh_l0", "bias_ih_l0", "bias_hh_l0", "weight_ih_l1", "weight_hh_l1", "bias_ih_l1", "bias_hh_l1", ]
  __buffers__ = []
  weight_ih_l0 : Tensor
  weight_hh_l0 : Tensor
  bias_ih_l0 : Tensor
  bias_hh_l0 : Tensor
  weight_ih_l1 : Tensor
  weight_hh_l1 : Tensor
  bias_ih_l1 : Tensor
  bias_hh_l1 : Tensor
  nonlinearity : str
  training : bool
  _is_full_backward_hook : NoneType
  _flat_weights_names : List[str]
  _all_weights : List[List[str]]
  _flat_weights : List[Tensor]
  dropout : Final[float] = 0.
  bidirectional : Final[bool] = False
  mode : Final[str] = "RNN_TANH"
  num_layers : Final[int] = 2
  bias : Final[bool] = True
  batch_first : Final[bool] = False
  proj_size : Final[int] = 0
  hidden_size : Final[int] = 8
  input_size : Final[int] = 4
  def forward__0(self: __torch__.torch.nn.modules.rnn.RNN,
    input: Tensor,
    hx: Optional[Tensor]=None) -> Tuple[Tensor, Tensor]:
    _0 = "For unbatched 2-D input, hx should also be 2-D but got {}-D tensor"
    _1 = "For batched 3-D input, hx should also be 3-D but got {}-D tensor"
    _2 = uninitialized(Optional[Tensor])
    is_batched = torch.eq(torch.dim(input), 3)
    if torch.__not__(is_batched):
      input1 = torch.unsqueeze(input, 1)
      if torch.__isnot__(hx, None):
        hx2 = unchecked_cast(Tensor, hx)
        if torch.ne(torch.dim(hx2), 2):
          _3 = torch.format(_0, torch.dim(hx2))
          ops.prim.RaiseException(_3)
        else:
          pass
        hx1 : Optional[Tensor] = torch.unsqueeze(hx2, 1)
      else:
        hx1 = hx
      input0, hx0 = input1, hx1
    else:
      if torch.__isnot__(hx, None):
        hx4 = unchecked_cast(Tensor, hx)
        _4, hx3 = torch.ne(torch.dim(hx4), 3), hx4
      else:
        _4, hx3 = False, hx
      if _4:
        hx6 = unchecked_cast(Tensor, hx3)
        _5 = torch.format(_1, torch.dim(hx6))
        ops.prim.RaiseException(_5)
        hx5 : Optional[Tensor] = _2
      else:
        hx5 = hx3
      input0, hx0 = input, hx5
    max_batch_size = torch.size(input0, 1)
    if torch.__is__(hx0, None):
      _6 = ops.prim.dtype(input0)
      _7 = ops.prim.device(input0)
      hx8 = torch.zeros([2, max_batch_size, 8], dtype=_6, layout=None, device=_7)
      hx7 = hx8
    else:
      hx9 = unchecked_cast(Tensor, hx0)
      hx10 = (self).permute_hidden(hx9, None, )
      hx7 = hx10
    _8 = (self).check_forward_args(input0, hx7, None, )
    _flat_weights = self._flat_weights
    training = self.training
    _9, _10 = torch.rnn_tanh(input0, hx7, _flat_weights, True, 2, 0., training, False, False)
    result = (_9, _10)
    output = (result)[0]
    hidden = (result)[1]
    if torch.__not__(is_batched):
      output1 = torch.squeeze(output, 1)
      hidden0, output0 = torch.squeeze(hidden, 1), output1
    else:
      hidden0, output0 = hidden, output
    _11 = (self).permute_hidden(hidden0, None, )
    return (output0, _11)
  def forward__1(self: __torch__.torch.nn.modules.rnn.RNN,
    input: __torch__.torch.nn.utils.rnn.PackedSequence,
    hx: Optional[Tensor]=None) -> Tuple[__torch__.torch.nn.utils.rnn.PackedSequence, Tensor]:
    input2, batch_sizes, sorted_indices, unsorted_indices, = input
    max_batch_size = int(torch.select(batch_sizes, 0, 0))
    if torch.__is__(hx, None):
      _12 = ops.prim.dtype(input2)
      _13 = ops.prim.device(input2)
      hx12 = torch.zeros([2, max_batch_size, 8], dtype=_12, layout=None, device=_13)
      hx11 = hx12
    else:
      hx13 = unchecked_cast(Tensor, hx)
      hx14 = (self).permute_hidden(hx13, sorted_indices, )
      hx11 = hx14
    _14 = (self).check_forward_args(input2, hx11, batch_sizes, )
    _flat_weights = self._flat_weights
    training = self.training
    _15, _16 = torch.rnn_tanh(input2, batch_sizes, hx11, _flat_weights, True, 2, 0., training, False)
    result = (_15, _16)
    output = (result)[0]
    hidden = (result)[1]
    output_packed = __torch__.torch.nn.utils.rnn.PackedSequence(output, batch_sizes, sorted_indices, unsorted_indices)
    _17 = (self).permute_hidden(hidden, unsorted_indices, )
    return (output_packed, _17)
  def permute_hidden(self: __torch__.torch.nn.modules.rnn.RNN,
    hx: Tensor,
    permutation: Optional[Tensor]) -> Tensor:
    _18 = __torch__.torch.nn.modules.rnn.apply_permutation
    if torch.__is__(permutation, None):
      _19 = hx
    else:
      permutation0 = unchecked_cast(Tensor, permutation)
      _19 = _18(hx, permutation0, 1, )
    return _19
  def check_forward_args(self: __torch__.torch.nn.modules.rnn.RNN,
    input: Tensor,
    hidden: Tensor,
    batch_sizes: Optional[Tensor]) -> NoneType:
    _20 = (self).check_input(input, batch_sizes, )
    expected_hidden_size = (self).get_expected_hidden_size(input, batch_sizes, )
    _21 = (self).check_hidden_size(hidden, expected_hidden_size, "Expected hidden size {}, got {}", )
    return None
  def check_input(self: __torch__.torch.nn.modules.rnn.RNN,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> NoneType:
    _22 = "input must have {} dimensions, got {}"
    _23 = "input.size(-1) must be equal to input_size. Expected {}, got {}"
    if torch.__isnot__(batch_sizes, None):
      expected_input_dim = 2
    else:
      expected_input_dim = 3
    _24 = torch.ne(torch.dim(input), expected_input_dim)
    if _24:
      _25 = torch.format(_22, expected_input_dim, torch.dim(input))
      ops.prim.RaiseException(_25)
    else:
      pass
    if torch.ne(4, torch.size(input, -1)):
      _26 = torch.format(_23, 4, torch.size(input, -1))
      ops.prim.RaiseException(_26)
    else:
      pass
    return None
  def get_expected_hidden_size(self: __torch__.torch.nn.modules.rnn.RNN,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> Tuple[int, int, int]:
    if torch.__isnot__(batch_sizes, None):
      batch_sizes0 = unchecked_cast(Tensor, batch_sizes)
      mini_batch0 = int(torch.select(batch_sizes0, 0, 0))
      mini_batch = mini_batch0
    else:
      mini_batch = torch.size(input, 1)
    return (2, mini_batch, 8)
  def check_hidden_size(self: __torch__.torch.nn.modules.rnn.RNN,
    hx: Tensor,
    expected_hidden_size: Tuple[int, int, int],
    msg: str="Expected hidden size {}, got {}") -> NoneType:
    _27 = torch.size(hx)
    _28, _29, _30, = expected_hidden_size
    if torch.ne(_27, [_28, _29, _30]):
      _31 = torch.format(msg, expected_hidden_size, torch.list(torch.size(hx)))
      ops.prim.RaiseException(_31)
    else:
      pass
    return None
class RNNCell(Module):
  __parameters__ = ["weight_ih", "weight_hh", "bias_ih", "bias_hh", ]
  __buffers__ = []
  weight_ih : Tensor
  weight_hh : Tensor
  bias_ih : Tensor
  bias_hh : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  nonlinearity : Final[str] = "tanh"
  bias : Final[bool] = True
  input_size : Final[int] = 4
  hidden_size : Final[int] = 8
  def forward(self: __torch__.torch.nn.modules.rnn.RNNCell,
    input: Tensor,
    hx: Optional[Tensor]=None) -> Tensor:
    _32 = "RNNCell: Expected input to be 1-D or 2-D but received {}-D tensor"
    _33 = torch.dim(input)
    if torch.__contains__([1, 2], _33):
      pass
    else:
      _34 = torch.format(_32, torch.dim(input))
      _35 = torch.add("AssertionError: ", _34)
      ops.prim.RaiseException(_35)
    is_batched = torch.eq(torch.dim(input), 2)
    if torch.__not__(is_batched):
      input3 = torch.unsqueeze(input, 0)
    else:
      input3 = input
    if torch.__is__(hx, None):
      _36 = torch.size(input3, 0)
      _37 = ops.prim.dtype(input3)
      _38 = ops.prim.device(input3)
      hx16 = torch.zeros([_36, 8], dtype=_37, layout=None, device=_38)
      hx15 = hx16
    else:
      hx17 = unchecked_cast(Tensor, hx)
      if torch.__not__(is_batched):
        hx18 = torch.unsqueeze(hx17, 0)
      else:
        hx18 = hx17
      hx15 = hx18
    weight_ih = self.weight_ih
    weight_hh = self.weight_hh
    bias_ih = self.bias_ih
    bias_hh = self.bias_hh
    ret = torch.rnn_tanh_cell(input3, hx15, weight_ih, weight_hh, bias_ih, bias_hh)
    if torch.__not__(is_batched):
      ret0 = torch.squeeze(ret, 0)
    else:
      ret0 = ret
    return ret0
class GRU(Module):
  __parameters__ = ["weight_ih_l0", "weight_hh_l0", "bias_ih_l0", "bias_hh_l0", "weight_ih_l1", "weight_hh_l1", "bias_ih_l1", "bias_hh_l1", ]
  __buffers__ = []
  weight_ih_l0 : Tensor
  weight_hh_l0 : Tensor
  bias_ih_l0 : Tensor
  bias_hh_l0 : Tensor
  weight_ih_l1 : Tensor
  weight_hh_l1 : Tensor
  bias_ih_l1 : Tensor
  bias_hh_l1 : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  _flat_weights_names : List[str]
  _all_weights : List[List[str]]
  _flat_weights : List[Tensor]
  dropout : Final[float] = 0.
  bidirectional : Final[bool] = False
  mode : Final[str] = "GRU"
  num_layers : Final[int] = 2
  bias : Final[bool] = True
  batch_first : Final[bool] = False
  proj_size : Final[int] = 0
  hidden_size : Final[int] = 8
  input_size : Final[int] = 4
  def forward__0(self: __torch__.torch.nn.modules.rnn.GRU,
    input: Tensor,
    hx: Optional[Tensor]=None) -> Tuple[Tensor, Tensor]:
    _39 = "For unbatched 2-D input, hx should also be 2-D but got {}-D tensor"
    _40 = "For batched 3-D input, hx should also be 3-D but got {}-D tensor"
    _41 = uninitialized(Optional[Tensor])
    is_batched = torch.eq(torch.dim(input), 3)
    if torch.__not__(is_batched):
      input5 = torch.unsqueeze(input, 1)
      if torch.__isnot__(hx, None):
        hx21 = unchecked_cast(Tensor, hx)
        if torch.ne(torch.dim(hx21), 2):
          _42 = torch.format(_39, torch.dim(hx21))
          ops.prim.RaiseException(_42)
        else:
          pass
        hx20 : Optional[Tensor] = torch.unsqueeze(hx21, 1)
      else:
        hx20 = hx
      input4, hx19 = input5, hx20
    else:
      if torch.__isnot__(hx, None):
        hx23 = unchecked_cast(Tensor, hx)
        _43, hx22 = torch.ne(torch.dim(hx23), 3), hx23
      else:
        _43, hx22 = False, hx
      if _43:
        hx25 = unchecked_cast(Tensor, hx22)
        _44 = torch.format(_40, torch.dim(hx25))
        ops.prim.RaiseException(_44)
        hx24 : Optional[Tensor] = _41
      else:
        hx24 = hx22
      input4, hx19 = input, hx24
    max_batch_size = torch.size(input4, 1)
    if torch.__is__(hx19, None):
      _45 = ops.prim.dtype(input4)
      _46 = ops.prim.device(input4)
      hx27 = torch.zeros([2, max_batch_size, 8], dtype=_45, layout=None, device=_46)
      hx26 = hx27
    else:
      hx28 = unchecked_cast(Tensor, hx19)
      hx29 = (self).permute_hidden(hx28, None, )
      hx26 = hx29
    _47 = (self).check_forward_args(input4, hx26, None, )
    _flat_weights = self._flat_weights
    training = self.training
    _48, _49 = torch.gru(input4, hx26, _flat_weights, True, 2, 0., training, False, False)
    if torch.__not__(is_batched):
      output2 = torch.squeeze(_48, 1)
      hidden, output = torch.squeeze(_49, 1), output2
    else:
      hidden, output = _49, _48
    _50 = (self).permute_hidden(hidden, None, )
    return (output, _50)
  def forward__1(self: __torch__.torch.nn.modules.rnn.GRU,
    input: __torch__.torch.nn.utils.rnn.PackedSequence,
    hx: Optional[Tensor]=None) -> Tuple[__torch__.torch.nn.utils.rnn.PackedSequence, Tensor]:
    input6, batch_sizes, sorted_indices, unsorted_indices, = input
    max_batch_size = torch.select(batch_sizes, 0, 0)
    max_batch_size0 = int(max_batch_size)
    if torch.__is__(hx, None):
      _51 = ops.prim.dtype(input6)
      _52 = ops.prim.device(input6)
      hx31 = torch.zeros([2, max_batch_size0, 8], dtype=_51, layout=None, device=_52)
      hx30 = hx31
    else:
      hx32 = unchecked_cast(Tensor, hx)
      hx33 = (self).permute_hidden(hx32, sorted_indices, )
      hx30 = hx33
    _53 = (self).check_forward_args(input6, hx30, batch_sizes, )
    _flat_weights = self._flat_weights
    training = self.training
    _54, _55 = torch.gru(input6, batch_sizes, hx30, _flat_weights, True, 2, 0., training, False)
    output_packed = __torch__.torch.nn.utils.rnn.PackedSequence(_54, batch_sizes, sorted_indices, unsorted_indices)
    _56 = (self).permute_hidden(_55, unsorted_indices, )
    return (output_packed, _56)
  def permute_hidden(self: __torch__.torch.nn.modules.rnn.GRU,
    hx: Tensor,
    permutation: Optional[Tensor]) -> Tensor:
    _57 = __torch__.torch.nn.modules.rnn.apply_permutation
    if torch.__is__(permutation, None):
      _58 = hx
    else:
      permutation1 = unchecked_cast(Tensor, permutation)
      _58 = _57(hx, permutation1, 1, )
    return _58
  def check_forward_args(self: __torch__.torch.nn.modules.rnn.GRU,
    input: Tensor,
    hidden: Tensor,
    batch_sizes: Optional[Tensor]) -> NoneType:
    _59 = (self).check_input(input, batch_sizes, )
    expected_hidden_size = (self).get_expected_hidden_size(input, batch_sizes, )
    _60 = (self).check_hidden_size(hidden, expected_hidden_size, "Expected hidden size {}, got {}", )
    return None
  def check_input(self: __torch__.torch.nn.modules.rnn.GRU,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> NoneType:
    _61 = "input must have {} dimensions, got {}"
    _62 = "input.size(-1) must be equal to input_size. Expected {}, got {}"
    if torch.__isnot__(batch_sizes, None):
      expected_input_dim = 2
    else:
      expected_input_dim = 3
    _63 = torch.ne(torch.dim(input), expected_input_dim)
    if _63:
      _64 = torch.format(_61, expected_input_dim, torch.dim(input))
      ops.prim.RaiseException(_64)
    else:
      pass
    if torch.ne(4, torch.size(input, -1)):
      _65 = torch.format(_62, 4, torch.size(input, -1))
      ops.prim.RaiseException(_65)
    else:
      pass
    return None
  def get_expected_hidden_size(self: __torch__.torch.nn.modules.rnn.GRU,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> Tuple[int, int, int]:
    if torch.__isnot__(batch_sizes, None):
      batch_sizes1 = unchecked_cast(Tensor, batch_sizes)
      mini_batch1 = int(torch.select(batch_sizes1, 0, 0))
      mini_batch = mini_batch1
    else:
      mini_batch = torch.size(input, 1)
    return (2, mini_batch, 8)
  def check_hidden_size(self: __torch__.torch.nn.modules.rnn.GRU,
    hx: Tensor,
    expected_hidden_size: Tuple[int, int, int],
    msg: str="Expected hidden size {}, got {}") -> NoneType:
    _66 = torch.size(hx)
    _67, _68, _69, = expected_hidden_size
    if torch.ne(_66, [_67, _68, _69]):
      _70 = torch.format(msg, expected_hidden_size, torch.list(torch.size(hx)))
      ops.prim.RaiseException(_70)
    else:
      pass
    return None
class GRUCell(Module):
  __parameters__ = ["weight_ih", "weight_hh", "bias_ih", "bias_hh", ]
  __buffers__ = []
  weight_ih : Tensor
  weight_hh : Tensor
  bias_ih : Tensor
  bias_hh : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  input_size : Final[int] = 4
  hidden_size : Final[int] = 8
  bias : Final[bool] = True
  def forward(self: __torch__.torch.nn.modules.rnn.GRUCell,
    input: Tensor,
    hx: Optional[Tensor]=None) -> Tensor:
    _71 = "GRUCell: Expected input to be 1-D or 2-D but received {}-D tensor"
    _72 = torch.dim(input)
    if torch.__contains__([1, 2], _72):
      pass
    else:
      _73 = torch.format(_71, torch.dim(input))
      _74 = torch.add("AssertionError: ", _73)
      ops.prim.RaiseException(_74)
    is_batched = torch.eq(torch.dim(input), 2)
    if torch.__not__(is_batched):
      input7 = torch.unsqueeze(input, 0)
    else:
      input7 = input
    if torch.__is__(hx, None):
      _75 = torch.size(input7, 0)
      _76 = ops.prim.dtype(input7)
      _77 = ops.prim.device(input7)
      hx35 = torch.zeros([_75, 8], dtype=_76, layout=None, device=_77)
      hx34 = hx35
    else:
      hx36 = unchecked_cast(Tensor, hx)
      if torch.__not__(is_batched):
        hx37 = torch.unsqueeze(hx36, 0)
      else:
        hx37 = hx36
      hx34 = hx37
    weight_ih = self.weight_ih
    weight_hh = self.weight_hh
    bias_ih = self.bias_ih
    bias_hh = self.bias_hh
    ret = torch.gru_cell(input7, hx34, weight_ih, weight_hh, bias_ih, bias_hh)
    if torch.__not__(is_batched):
      ret1 = torch.squeeze(ret, 0)
    else:
      ret1 = ret
    return ret1
class LSTM(Module):
  __parameters__ = ["weight_ih_l0", "weight_hh_l0", "bias_ih_l0", "bias_hh_l0", "weight_ih_l1", "weight_hh_l1", "bias_ih_l1", "bias_hh_l1", ]
  __buffers__ = []
  weight_ih_l0 : Tensor
  weight_hh_l0 : Tensor
  bias_ih_l0 : Tensor
  bias_hh_l0 : Tensor
  weight_ih_l1 : Tensor
  weight_hh_l1 : Tensor
  bias_ih_l1 : Tensor
  bias_hh_l1 : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  _flat_weights_names : List[str]
  _all_weights : List[List[str]]
  _flat_weights : List[Tensor]
  dropout : Final[float] = 0.
  bidirectional : Final[bool] = False
  mode : Final[str] = "LSTM"
  num_layers : Final[int] = 2
  bias : Final[bool] = True
  batch_first : Final[bool] = False
  proj_size : Final[int] = 0
  hidden_size : Final[int] = 8
  input_size : Final[int] = 4
  def forward__0(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    hx: Optional[Tuple[Tensor, Tensor]]=None) -> Tuple[Tensor, Tuple[Tensor, Tensor]]:
    _78 = "For batched 3-D input, hx and cx should also be 3-D but got ({}-D, {}-D) tensors"
    _79 = "For unbatched 2-D input, hx and cx should also be 2-D but got ({}-D, {}-D) tensors"
    is_batched = torch.eq(torch.dim(input), 3)
    if torch.__not__(is_batched):
      input8 = torch.unsqueeze(input, 1)
    else:
      input8 = input
    max_batch_size = torch.size(input8, 1)
    if torch.__is__(hx, None):
      _80 = ops.prim.dtype(input8)
      _81 = ops.prim.device(input8)
      h_zeros = torch.zeros([2, max_batch_size, 8], dtype=_80, layout=None, device=_81)
      _82 = ops.prim.dtype(input8)
      _83 = ops.prim.device(input8)
      c_zeros = torch.zeros([2, max_batch_size, 8], dtype=_82, layout=None, device=_83)
      hx38 = (h_zeros, c_zeros)
    else:
      hx39 = unchecked_cast(Tuple[Tensor, Tensor], hx)
      if is_batched:
        _84 = torch.ne(torch.dim((hx39)[0]), 3)
        if _84:
          _85 = True
        else:
          _86 = torch.ne(torch.dim((hx39)[1]), 3)
          _85 = _86
        if _85:
          msg = torch.format(_78, torch.dim((hx39)[0]), torch.dim((hx39)[1]))
          ops.prim.RaiseException(msg)
        else:
          pass
        hx40 = hx39
      else:
        _87 = torch.ne(torch.dim((hx39)[0]), 2)
        if _87:
          _88 = True
        else:
          _89 = torch.ne(torch.dim((hx39)[1]), 2)
          _88 = _89
        if _88:
          msg0 = torch.format(_79, torch.dim((hx39)[0]), torch.dim((hx39)[1]))
          ops.prim.RaiseException(msg0)
        else:
          pass
        hx41 = (torch.unsqueeze((hx39)[0], 1), torch.unsqueeze((hx39)[1], 1))
        hx40 = hx41
      hx42 = (self).permute_hidden(hx40, None, )
      hx38 = hx42
    _90 = (self).check_forward_args(input8, hx38, None, )
    _flat_weights = self._flat_weights
    training = self.training
    _91, _92, = hx38
    _93, _94, _95 = torch.lstm(input8, [_91, _92], _flat_weights, True, 2, 0., training, False, False)
    hidden = (_94, _95)
    if torch.__not__(is_batched):
      output3 = torch.squeeze(_93, 1)
      hidden2 = (torch.squeeze(_94, 1), torch.squeeze(_95, 1))
      hidden1, output = hidden2, output3
    else:
      hidden1, output = hidden, _93
    _96 = (self).permute_hidden(hidden1, None, )
    return (output, _96)
  def forward__1(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: __torch__.torch.nn.utils.rnn.PackedSequence,
    hx: Optional[Tuple[Tensor, Tensor]]=None) -> Tuple[__torch__.torch.nn.utils.rnn.PackedSequence, Tuple[Tensor, Tensor]]:
    input9, batch_sizes, sorted_indices, unsorted_indices, = input
    max_batch_size = torch.select(batch_sizes, 0, 0)
    max_batch_size1 = int(max_batch_size)
    if torch.__is__(hx, None):
      _97 = ops.prim.dtype(input9)
      _98 = ops.prim.device(input9)
      h_zeros = torch.zeros([2, max_batch_size1, 8], dtype=_97, layout=None, device=_98)
      _99 = ops.prim.dtype(input9)
      _100 = ops.prim.device(input9)
      c_zeros = torch.zeros([2, max_batch_size1, 8], dtype=_99, layout=None, device=_100)
      hx43 = (h_zeros, c_zeros)
    else:
      hx44 = unchecked_cast(Tuple[Tensor, Tensor], hx)
      hx45 = (self).permute_hidden(hx44, sorted_indices, )
      hx43 = hx45
    _101 = (self).check_forward_args(input9, hx43, batch_sizes, )
    _flat_weights = self._flat_weights
    training = self.training
    _102, _103, = hx43
    _104, _105, _106 = torch.lstm(input9, batch_sizes, [_102, _103], _flat_weights, True, 2, 0., training, False)
    hidden = (_105, _106)
    output_packed = __torch__.torch.nn.utils.rnn.PackedSequence(_104, batch_sizes, sorted_indices, unsorted_indices)
    _107 = (self).permute_hidden(hidden, unsorted_indices, )
    return (output_packed, _107)
  def permute_hidden(self: __torch__.torch.nn.modules.rnn.LSTM,
    hx: Tuple[Tensor, Tensor],
    permutation: Optional[Tensor]) -> Tuple[Tensor, Tensor]:
    _108 = __torch__.torch.nn.modules.rnn.apply_permutation
    if torch.__is__(permutation, None):
      _109 = hx
    else:
      permutation2 = unchecked_cast(Tensor, permutation)
      _110 = (_108((hx)[0], permutation2, 1, ), _108((hx)[1], permutation2, 1, ))
      _109 = _110
    return _109
  def check_forward_args(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    hidden: Tuple[Tensor, Tensor],
    batch_sizes: Optional[Tensor]) -> NoneType:
    _111 = "Expected hidden[0] size {}, got {}"
    _112 = "Expected hidden[1] size {}, got {}"
    _113 = (self).check_input(input, batch_sizes, )
    _114 = (hidden)[0]
    _115 = (self).get_expected_hidden_size(input, batch_sizes, )
    _116 = (self).check_hidden_size(_114, _115, _111, )
    _117 = (hidden)[1]
    _118 = (self).get_expected_cell_size(input, batch_sizes, )
    _119 = (self).check_hidden_size(_117, _118, _112, )
    return None
  def check_input(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> NoneType:
    _120 = "input must have {} dimensions, got {}"
    _121 = "input.size(-1) must be equal to input_size. Expected {}, got {}"
    if torch.__isnot__(batch_sizes, None):
      expected_input_dim = 2
    else:
      expected_input_dim = 3
    _122 = torch.ne(torch.dim(input), expected_input_dim)
    if _122:
      _123 = torch.format(_120, expected_input_dim, torch.dim(input))
      ops.prim.RaiseException(_123)
    else:
      pass
    if torch.ne(4, torch.size(input, -1)):
      _124 = torch.format(_121, 4, torch.size(input, -1))
      ops.prim.RaiseException(_124)
    else:
      pass
    return None
  def check_hidden_size(self: __torch__.torch.nn.modules.rnn.LSTM,
    hx: Tensor,
    expected_hidden_size: Tuple[int, int, int],
    msg: str="Expected hidden size {}, got {}") -> NoneType:
    _125 = torch.size(hx)
    _126, _127, _128, = expected_hidden_size
    if torch.ne(_125, [_126, _127, _128]):
      _129 = torch.format(msg, expected_hidden_size, torch.list(torch.size(hx)))
      ops.prim.RaiseException(_129)
    else:
      pass
    return None
  def get_expected_hidden_size(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> Tuple[int, int, int]:
    if torch.__isnot__(batch_sizes, None):
      batch_sizes2 = unchecked_cast(Tensor, batch_sizes)
      mini_batch2 = int(torch.select(batch_sizes2, 0, 0))
      mini_batch = mini_batch2
    else:
      mini_batch = torch.size(input, 1)
    return (2, mini_batch, 8)
  def get_expected_cell_size(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> Tuple[int, int, int]:
    if torch.__isnot__(batch_sizes, None):
      batch_sizes3 = unchecked_cast(Tensor, batch_sizes)
      mini_batch3 = int(torch.select(batch_sizes3, 0, 0))
      mini_batch = mini_batch3
    else:
      mini_batch = torch.size(input, 1)
    return (2, mini_batch, 8)
class LSTMCell(Module):
  __parameters__ = ["weight_ih", "weight_hh", "bias_ih", "bias_hh", ]
  __buffers__ = []
  weight_ih : Tensor
  weight_hh : Tensor
  bias_ih : Tensor
  bias_hh : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  input_size : Final[int] = 4
  hidden_size : Final[int] = 8
  bias : Final[bool] = True
  def forward(self: __torch__.torch.nn.modules.rnn.LSTMCell,
    input: Tensor,
    hx: Optional[Tuple[Tensor, Tensor]]=None) -> Tuple[Tensor, Tensor]:
    _130 = "LSTMCell: Expected input to be 1-D or 2-D but received {}-D tensor"
    _131 = torch.dim(input)
    if torch.__contains__([1, 2], _131):
      pass
    else:
      _132 = torch.format(_130, torch.dim(input))
      _133 = torch.add("AssertionError: ", _132)
      ops.prim.RaiseException(_133)
    is_batched = torch.eq(torch.dim(input), 2)
    if torch.__not__(is_batched):
      input10 = torch.unsqueeze(input, 0)
    else:
      input10 = input
    if torch.__is__(hx, None):
      _134 = torch.size(input10, 0)
      _135 = ops.prim.dtype(input10)
      _136 = ops.prim.device(input10)
      zeros = torch.zeros([_134, 8], dtype=_135, layout=None, device=_136)
      hx46 = (zeros, zeros)
    else:
      hx47 = unchecked_cast(Tuple[Tensor, Tensor], hx)
      if torch.__not__(is_batched):
        _137 = (torch.unsqueeze((hx47)[0], 0), torch.unsqueeze((hx47)[1], 0))
        hx48 = _137
      else:
        hx48 = hx47
      hx46 = hx48
    weight_ih = self.weight_ih
    weight_hh = self.weight_hh
    bias_ih = self.bias_ih
    bias_hh = self.bias_hh
    _138, _139, = hx46
    _140, _141 = torch.lstm_cell(input10, [_138, _139], weight_ih, weight_hh, bias_ih, bias_hh)
    ret = (_140, _141)
    if torch.__not__(is_batched):
      ret3 = (torch.squeeze(_140, 0), torch.squeeze(_141, 0))
      ret2 = ret3
    else:
      ret2 = ret
    return ret2
def apply_permutation(tensor: Tensor,
    permutation: Tensor,
    dim: int=1) -> Tensor:
  _142 = torch.index_select(tensor, dim, permutation)
  return _142
